/****************************************************************************
 *
 * Copy right:   Qx.
 * File name:    UartTask.h
 * Description:  串口任务
 * History:      2021-03-05
 *
 ****************************************************************************/
#include "commontypedef.h"
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "hal_module_adapter.h"
#include <stdlib.h>
#include "numeric.h"
#include "AppSignal.h"

#define  PROC_UART_TASK_STACK_SIZE (1024)

#define BMS_ADDRESS_CODE    0x01
#define UART_READ_CODE      0x03
#define UART_WRITE_CODE     0x10
#define UART_ENCRYPT_CODE   0x05
#define UART_WRITE_FLAG     0x01
#define UART_READ_FLAG      0x00
typedef enum
{
    PROCESS_UART_STATE_ENCRYPT = 0,
    PROCESS_UART_STATE_IDLE,
    PROCESS_UART_STATE_READ,
    PROCESS_UART_STATE_WRITE,
    PROCESS_UART_STATE_UPDATE,
    PROCESS_UART_STATE_SLEEP
}process_Uart;
typedef struct _UartAnswerData
{
	volatile BOOL UartFlag;
    UINT8 Header[3];
    UINT8 data[120];
    UINT16 len;
}UartAnswerData_S;
typedef struct _UartWriteDataType
{
    volatile UINT8 WriteCmd; 
    UINT8 Data[2];
}UartWriteData_S;
typedef struct _UartQueryType
{
    UINT8 Bms_Address; 
    UINT8 Bms_Funcode; 
    UINT8 Reg_Begin_H; 
    UINT8 Reg_Begin_L; 
    UINT8 Reg_Num_H; 
    UINT8 Reg_Num_L; 
    UINT8 CRC_L;
    UINT8 CRC_H;
}UartQueryType;
typedef struct _UartWriteMsgType
{
    UINT8 Bms_Address; 
    UINT8 Bms_Funcode; 
    UINT8 Reg_Begin_H; 
    UINT8 Reg_Begin_L; 
    UINT8 Reg_Num_H; 
    UINT8 Reg_Num_L; 
    UINT8 Data_Count;
    UINT8 Data[2];
    UINT8 CRC_L;
    UINT8 CRC_H;
}UartWriteMsgType;
void AppTaskUartInit(void *arg);
void AppTaskUartDeInit(void *arg);