/****************************************************************************
 *
 * Copy right:   2021-, Copyrigths of RLWL Ltd.Zhen C
 * File name:    AppTaskCan.h
 * Description:  App Task Can H file 
 * History:      Rev3.0   2021-07-06
 *
 ****************************************************************************/
#include "AppTaskCan.h"


static StaticTask_t gProcess_Can_Rx_Task_t;
static UINT8 		gProcess_Can_Rx_TaskStack[PROC_CAN_RX_TASK_STACK_SIZE];
static process_CAN	gProcess_CAN_Task = PROCESS_CAN_STATE_IDLE;
#define 			PROC_CAN_STATE_SWITCH(a)  (gProcess_CAN_Task = a)

void AppTaskCanInit(void* arg)
{
    osThreadAttr_t task_rx_attr;
    Can_InitType param;
    param.baudrate = CAN_250Kbps;
	param.mode = REQOP_NORMAL;	
	param.packType = STD_PACK;
    memset(&task_rx_attr,0,sizeof(task_rx_attr));
    memset(gProcess_Can_Rx_TaskStack, 0, PROC_CAN_RX_TASK_STACK_SIZE);
    task_rx_attr.name = "Can_Task";
    task_rx_attr.stack_mem = gProcess_Can_Rx_TaskStack;
    task_rx_attr.stack_size = PROC_CAN_RX_TASK_STACK_SIZE;
    task_rx_attr.priority = osPriorityBelowNormal7;
    task_rx_attr.cb_mem = &gProcess_Can_Rx_Task_t;
    task_rx_attr.cb_size = sizeof(StaticTask_t);
    HAL_Can_Init(param);
    osDelay(1000);
    osThreadNew(Can_Receive, NULL, &task_rx_attr);
}

static void Can_Receive()
{    
	PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_IDLE);
    while(true)
    {	
		switch(gProcess_CAN_Task)
		{
			case PROCESS_CAN_STATE_IDLE:
			{
				osDelay(100);
				break;				
			}
			case PROCESS_CAN_STATE_WORK:
			{
				break;
			}	
	        case PROCESS_CAN_STATE_SLEEP:
	        {	            
	            HAL_Can_Sleep();	           
	            break;
	       	}
	   }
	}      
}




