/****************************************************************************
 *
 * Copy right:   Qx.Chen Jie
 * File name:    AppTaskControl.c
 * Description:  LED控制和蜂鸣器控制和继电器控制逻辑判定
 * History:      2021-07-05
 * Version:      V3.0
 ****************************************************************************/
#include "AppTaskControl.h"

static StaticTask_t                 gProcess_Control_Task_t;
static UINT8                        gProcess_Control_TaskStack[PROC_CONTROL_TASK_STACK_SIZE];
static osThreadId_t                 ControlTaskId = NULL;
static process_control 		        gProcess_Control_Task = PROCESS_CONTROL_STATE_IDLE;
#define PROC_CONTROL_STATE_SWITCH(a)    (gProcess_Control_Task = a)

static void ControlTask(void* arg)
{
    osDelay(5000);
    while (true)
    {
        osDelay(100);
    }
}
void AppTaskControlInit(void *arg)
{
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Control_TaskStack, 0xA5, PROC_CONTROL_TASK_STACK_SIZE);
    task_attr.name = "Control_Task";
    task_attr.stack_mem = gProcess_Control_TaskStack;
    task_attr.stack_size = PROC_CONTROL_TASK_STACK_SIZE;
    task_attr.priority = osPriorityBelowNormal;
    task_attr.cb_mem = &gProcess_Control_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    ControlTaskId = osThreadNew(ControlTask, NULL, &task_attr);
}
void AppTaskControlDeInit(void *arg)
{
    osThreadTerminate(ControlTaskId);
    ControlTaskId = NULL;
}