/****************************************************************************
 *
 * Copy right:   Qx.Chen jie
 * File name:    AppTaskGps.c
 * Description:  Gps处理任务和三轴数据处理及获取
 * History:      2021-03-07 2021-07-15
 * Version:      V3.0
 ****************************************************************************/
#include "AppTaskGps.h"
static QueueHandle_t norGpsHandle = NULL;
static osThreadId_t gpsTaskHandle = NULL;
static StaticTask_t gpsTask = NULL;
static UINT8 gpsTaskStack[GPS_TASK_STACK_SIZE];

static void GpsTask(void* arg)
{
    if(GpsMutex == NULL)
    {
        GpsMutex = osMutexNew(NULL);
    }    
    while(1)
    {
        osDelay(1000);
    }
}
void AppTaskGpsInit(void *arg)
{

	if(norGpsHandle == NULL)
	{
		norGpsHandle = osMessageQueueNew(1,sizeof(gpsReqMsg), NULL);
		if(norGpsHandle == NULL)
			return;
	}
	if(gpsTaskHandle == NULL)
	{
		osThreadAttr_t task_attr;
		memset(&task_attr , 0 , sizeof(task_attr));
		task_attr.name = "GPS";
		task_attr.priority = osPriorityBelowNormal6;
		task_attr.cb_mem = &gpsTask;
		task_attr.cb_size = sizeof(StaticTask_t);
		task_attr.stack_mem = gpsTaskStack;
		task_attr.stack_size =GPS_TASK_STACK_SIZE;
		memset(& gpsTaskStack, 0xa5, GPS_TASK_STACK_SIZE);
		gpsTaskHandle = osThreadNew(GpsTask , NULL,&task_attr);
		if(gpsTaskHandle == NULL)
			return;
	}
}
void AppTaskGpsDeInit(void *arg)
{
    osThreadTerminate(gpsTaskHandle);
    gpsTaskHandle = NULL;
}